# Try it on Google Colab!

Use these notebooks to train driving policies on `highway-env`.

### [:ledger: A Model-based Reinforcement Learning tutorial on Parking](https://colab.research.google.com/github/eleurent/highway-env/blob/master/scripts/parking_model_based.ipynb)

A tutorial written for [RLSS 2019](https://rlss.inria.fr/) and demonstrating the principle of model-based reinforcement learning on the `parking-v0` task.

### [:ledger: Trajectory Planning on Highway](https://colab.research.google.com/github/eleurent/highway-env/blob/master/scripts/highway_planning.ipynb)

Plan a trajectory on `highway-v0` using the [OPD](https://hal.archives-ouvertes.fr/hal-00830182/) implementation from [rl-agents](https://github.com/eleurent/rl-agents).

### [:ledger: Parking with Hindsight Experience Replay](https://colab.research.google.com/github/eleurent/highway-env/blob/master/scripts/parking_her.ipynb)

Train a goal-conditioned `parking-v0` policy using the [HER](https://arxiv.org/abs/1707.01495) implementation from [stable-baselines](https://github.com/hill-a/stable-baselines).
